import argparse, sys

from os import putenv


if not sys.argv[0].endswith('mbus.py'):
	parser = argparse.ArgumentParser()
	parser.add_argument('urls', nargs=argparse.REMAINDER, help='Urls to open in the browser')
	parser.add_argument('--engine-enable-logging', '-l', help='Turn on webengine\'s process logging')
	parser.add_argument('--engine-disable-gpu', '-g', help='Disable hardware rendering for webengine')
	parser.add_argument('--engine-single-process', '-s', help='Run all tabs in a single process')
	parser.add_argument('--engine-remote-devtools', '-d', nargs='?', default='Default', help='Enable webengine\'s remote dev tools')
	parser.add_argument('--profile', '-p', default='Default', help='Use a different profile')
	args = parser.parse_args()


	profile = args.profile
	devtools = args.engine_remote_devtools
	engine_args = []

	if not args.engine_enable_logging:
		engine_args.append('--disable-logging')

	if args.engine_disable_gpu:
		engine_args.append('--disable-gpu')

	if args.engine_single_process:
		engine_args.append('--single-process')

	else:
		engine_args.append('--process-per-site')


	putenv('QTWEBENGINE_CHROMIUM_FLAGS', ' '.join(engine_args))

	if devtools != 'Default':
		port = '8058' if not devtools else devtools
		putenv('QTWEBENGINE_REMOTE_DEBUGGING', port)

else:
	profile = 'Default'
