from .connection import db
from . import get


def bookmark(rowid):
	row = db.fetch('bookmarks', rowid)

	if not row:
		return

	return row.Remove()


def search(keyword):
	cache = db.cache['search']
	row = db.fetch('search', keyword=keyword)

	if not row:
		return

	if row.Remove():
		cache.remove(row.keyword)
		return True

	else:
		return False


def permission(domain):
	cache = db.cache['siteoptions']
	row = get.permissions(domain)

	if not row:
		return

	if row.Remove():
		cache.remove(domain)
		return True

	else:
		return False


def mastoaccount(fullname):
	cache = db.cache['mastodon']
	row = get.mastoaccount(fullname)

	if not row:
		return

	if row.Remove():
		cache.remove(fullname)
		return True

	else:
		return False


def cookie(data):
	fields = db.GetFields('cookies', ['id', 'value'])
	newdata = {}

	for k, v in data.items():
		if k in fields:
			newdata[k] = v

	rows = db.fetch('cookies', **newdata, single=False)

	for row in rows:
		row.Remove()
