import sys

from . import debstable
from .config import var
from .database import db, put

from .Lib.IzzyLib import logging

from PyQt5.QtCore import *
from PyQt5.QtWebEngineCore import *


def RegisterScheme(name):
	scheme = QWebEngineUrlScheme(name.encode())
	scheme.setFlags(
		#QWebEngineUrlScheme.LocalScheme |
		QWebEngineUrlScheme.LocalAccessAllowed |
		QWebEngineUrlScheme.ViewSourceAllowed
	)

	QWebEngineUrlScheme.registerScheme(scheme)


class LocalHandler(QWebEngineUrlSchemeHandler):
	def __init__(self, parent):
		self.window = parent

		if not debstable:
			scheme = QWebEngineUrlScheme.schemeByName(var.local.encode())

			if scheme.name() == b'':
				logging.critical(f'Failed to register scheme: {var.local}. Exiting...')
				parent.close()

		super().__init__(parent.profile)
		parent.profile.installUrlSchemeHandler(var.local.encode(), self)


	def _check_initiator(self, request):
		initiator = request.initiator()
		requrl = request.requestUrl()

		if requrl.scheme() != var.local:
			logging.warning(f'Blocking malicious request from {initiator.toDisplayString()} to {request_url.toDisplayString()}')
			request.fail(QWebEngineUrlRequestJob.RequestDenied)
			return False

		return True


	def requestStarted(self, request):
		url = request.requestUrl()
		path = url.path()

		if not self._check_initiator(request):
			return

		if url.host() == 'home':
			mimetype = 'text/html'
			data = b'<html><head><title>MERP!</title><body>UvU</body></html>'

		else:
			mimetype = 'text/html'
			data = '<html><head><title>QtWeb</title><body>heck</body></html>'

		buf = QBuffer(parent=self)
		buf.open(QIODevice.WriteOnly)
		buf.write(data)
		buf.seek(0)
		buf.close()
		request.reply(mimetype.encode('ascii'), buf)
