from pathlib import Path

from .config import var

from .Lib.IzzyLib import logging


class JsFuncs(object):
	def __init__(self, webview):
		self.webview = webview


	def SoundcloudPlayer(self, action):
		if self.webview.url().host() != 'soundcloud.com':
			logging.debug('Not a soundcloud page')
			return False

		action = action.lower()
		actions = ['play', 'prev', 'next', 'shuffle', 'repeat', 'mute']

		if action not in actions:
			logging.error('Not a valid SoundcloudPlayer action:', action)
			return False

		if action in ['shuffle', 'repeat']:
			js = f'document.getElementsByClassName("playControls__{action}")[0].children[0].click();'

		elif action == 'mute':
			js = f'document.getElementsByClassName("volume__button")[0].click();'

		else:
			js = f'document.getElementsByClassName("playControls__{action}")[0].click();'

		self.webview.page().runJavaScript(js)


	def SoundcloudInfo(self, callback):
		self.webview.page().runJavaScript('QtWebGetInfo()', callback)
